// JavaScript
// name cahrts3d.js
// made in http://mykaralw.pochta.ru.
//    .
//  TextBuffer.      .
//---------------------------------
//  :
// wid,hei -      .
// dat() -   .
// name,nameD -     .
// col_p(),col_n() -    .
// bgCol() - 3    +  .
// tinfo -     [true-false].
// t_br -   

function textcharts3d (wid,hei,dat,delta,t_br,nameC,nameD,col_p,col_n,bgCol,tinfo)
{
	var dat_col;
	var temp_dat = 0;
	var max_dat = 0;
	var min_dat = 0;
	var nr_dat = dat.length;
	var n_dat = new Array (nr_dat);
	var max_nr = 0;
	var num_dat = 0;
	var dat_wid = 0;
	var dat_hei = 0;
	var hei_null = 0;
	var hei_p = 0;
	var dat_m = 0;
	var tbuf = '';
	var tbr = '';
	for (var i = 0; i < nr_dat; i++)
	{
		n_dat[i] = dat[i].length;
		num_dat += n_dat[i];
		if (max_nr < n_dat[i]) max_nr = n_dat[i];
	}
	dat_wid = Math.ceil ((wid - (t_br * max_nr))/ (nr_dat * max_nr));
	for (var i = 0; i < nr_dat; i++) for (var j = 0; j < n_dat[i]; j++) dat[i][j] *= 1;
	for (var i = 0; i < nr_dat; i++)
	{
		for (var j = 0; j < n_dat[i]; j++)
		{
			temp_dat = dat[i][j];
			if (max_dat < temp_dat) max_dat = temp_dat;
			if (min_dat > temp_dat) min_dat = temp_dat;
		}
	}
	dat_m = (hei - ((nr_dat - 1) * delta)) / (max_dat - min_dat);
	hei_p = Math.ceil (dat_m * max_dat);
	if (t_br != 0)
	{
		tbr = '<td><table bgcolor="' + bgCol[1] + '" width="' + t_br + '" height="' + (hei_p - 1) + '" cellpadding="0" cellspacing="0" border="0" rules="none"><tbody><tr><td></td></tr></tbody></table></td>\n';
	}
	tbuf += '<table bgcolor="' + bgCol[0] + '"><tbody><tr><td>\n';
	tbuf += '<table bgcolor="' + bgCol[2] + '" width="' + wid + '" height="' + hei + '" cellpadding="0" cellspacing="0" border="1" rules="none">\n<caption><b>' + nameC + '</b></caption>\n<tbody><tr valign="top">';
	for (var j = 0; j < max_nr; j++)
	{
		for (var i = 0; i < nr_dat; i++)
		{
			tbuf += '<td>\n';
			if ((n_dat[i] - 1) < j)
			{
				temp_dat = 0;
			}
			else
			{
				temp_dat = dat[i][j];
			}
			if (temp_dat < 0)
			{
				dat_hei = Math.ceil (-dat_m * temp_dat);
				hei_null = hei_p + ((nr_dat - i - 1) * delta);
				dat_col = col_n [i % col_n.length];
			}
			else
			{
				dat_hei = Math.ceil (dat_m * temp_dat);
				hei_null = hei_p - dat_hei + ((nr_dat - i - 1) * delta);
				dat_col = col_p [i % col_p.length];
			}
			if (hei_null != 0)
			{
				if (hei_null > hei_p)
				{
					tbuf += '<table bgcolor="' + bgCol[1] + '" width="' + dat_wid + '" height="' + (hei_p - 1) + '" cellpadding="0" cellspacing="0" border="0" rules="none"><tbody><tr><td></td></tr></tbody></table>\n';
					tbuf += '<table width="' + dat_wid + '" height="' + (hei_null - hei_p + 1) + '" cellpadding="0" cellspacing="0" border="0" rules="none"><tbody><tr><td></td></tr></tbody></table>\n';
				}
				else
				{
					tbuf += '<table bgcolor="' + bgCol[1] + '" width="' + dat_wid + '" height="' + hei_null + '" cellpadding="0" cellspacing="0" border="0" rules="none"><tbody><tr><td></td></tr></tbody></table>\n';
				}
			}
			tbuf += '<table width="' + dat_wid + '" height="' + dat_hei + '" bgcolor="' + dat_col + '" cellpadding="0" cellspacing="0" border="1" rules="none" bordercolor="' + bgCol[3] + '"><tbody><tr><td></td></tr></tbody></table>\n';
			tbuf += '</td>\n';
		}
		tbuf += tbr;
	}
	tbuf += '</tr></tbody></table>\n';
	if (tinfo)
	{
		tbuf += '<table><tbody>\n<tr><td><i><b> :</b></i> ' + wid + 'x' + hei + '</td></tr>\n';
		tbuf += '<tr><td><i><b>- :</b></i> ' + num_dat + '</td></tr>\n</tbody></table>\n';
	}
	tbuf += '<table cellpadding="1" cellspacing="0" border="1">\n<caption><b>' + nameD + '</b></caption>\n<tbody>\n';
	tbuf += '<tr><th></th>';
	for (var j = 0; j < max_nr; j++)
	{
		tbuf += '<th>'+ (j + 1) + '</th>\n';
	}
	tbuf += '</tr>';
	for (var i = 0; i < nr_dat; i++)
	{
		tbuf += '<tr  align="center" bgcolor="' + (col_p [i % col_p.length]) + '">\n<th>' + (i + 1) + '</th>';
		for (var j = 0; j < n_dat[i]; j++)
		{
			tbuf += '<td>'+ dat[i][j] + '</td>\n';
		}
		tbuf += '</tr>\n';
	}
	tbuf += '</tbody></table>\n';
	tbuf += '</td></tr></tbody></table>\n';
	return tbuf;
}
//end script
